﻿Public Class Form1

    Dim easyIntegrator1 As New cipeinet.EasyIntegrator
    Dim SysIO As System.IO.File

    Private Sub Approved()
        TextBox_ResultFields.Clear()
        TextBox_ResultFields.AppendText("                              Date: " & DateAndTime.Now & vbCrLf & vbCrLf)
        TextBox_ResultFields.AppendText("Merchandise Description and Price etc." & vbCrLf)
        TextBox_ResultFields.AppendText("Merchandise Description and Price etc." & vbCrLf & vbCrLf & vbCrLf)
        TextBox_ResultFields.AppendText("                              Total: " & TextBox_AmountTotal.Text & vbCrLf)
        TextBox_ResultFields.AppendText("Acct: " & Strings.Right(easyIntegrator1.resultsFields.MaskedAccount, 6) & vbCrLf)
        TextBox_ResultFields.AppendText("CardType: " & easyIntegrator1.resultsFields.AccountCardType & vbCrLf)
        TextBox_ResultFields.AppendText("Transaction Type: " & easyIntegrator1.resultsFields.TransactionType & vbCrLf)
        TextBox_ResultFields.AppendText("Approval Code: " & easyIntegrator1.resultsFields.ApprovalNumberResult & vbCrLf)
        TextBox_ResultFields.AppendText("Entry Method: " & easyIntegrator1.resultsFields.AccountEntryMethod & vbCrLf)
        TextBox_ResultFields.AppendText("Batch No: " & easyIntegrator1.resultsFields.BatchNumber & vbCrLf)
        TextBox_ResultFields.AppendText("Currency: " & easyIntegrator1.resultsFields.CurrencyIndicator & vbCrLf)
        TextBox_ResultFields.AppendText("Auth Mode: " & easyIntegrator1.resultsFields.AuthorizationMode & vbCrLf)
        TextBox_ResultFields.AppendText("AID: " & easyIntegrator1.resultsFields.AID & vbCrLf)
        TextBox_ResultFields.AppendText("TVR: " & easyIntegrator1.resultsFields.TVR & vbCrLf)
        TextBox_ResultFields.AppendText("IAD: " & easyIntegrator1.resultsFields.IAD & vbCrLf)
        TextBox_ResultFields.AppendText("TSI: " & easyIntegrator1.resultsFields.TSI & vbCrLf)
        TextBox_ResultFields.AppendText("ARC: " & easyIntegrator1.resultsFields.ARC & vbCrLf)
        TextBox_ResultFields.AppendText("CVM: " & easyIntegrator1.resultsFields.CardHolderVerificationMethod & vbCrLf & vbCrLf)
        TextBox_ResultFields.AppendText("     I AGREE TO PAY ABOVE" & vbCrLf)
        TextBox_ResultFields.AppendText("    TOTAL AMOUNT ACCORDING" & vbCrLf)
        TextBox_ResultFields.AppendText("   TO CARD ISSUER AGREEMENT" & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
        TextBox_ResultFields.AppendText("X_______________________________" & vbCrLf)
        TextBox_ResultFields.AppendText(easyIntegrator1.resultsFields.BillingName & vbCrLf & vbCrLf & vbCrLf)

    End Sub

    Private Sub Decline()
        TextBox_ResultFields.AppendText("Loop back and ask for another form of payment" & vbCrLf)
    End Sub

    Private Sub ConvertSignature()
        Dim sigFilename As String = String.Concat("Sig_" & DateTime.Now.ToString("yyyy-MM-dd HH.mm.ss") & ".bmp")
        easyIntegrator1.utilities.SaveSignatureAsBMP(easyIntegrator1.resultsFields.Signature, sigFilename)
        If System.IO.File.Exists(sigFilename) Then
            SignatureBox.Image = Image.FromFile(sigFilename)
        Else SignatureBox.Image = New Bitmap(2, 2)
        End If
    End Sub


    Private Sub Button_Setup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Setup.Click
        TextBox_Setup.Text = easyIntegrator1.Setup(TextBox_Setup.Text)

        Dim objWriter As New System.IO.StreamWriter("Setup1.txt")
        objWriter.Write(TextBox_Setup.Text)
        objWriter.Close()
    End Sub

    Private Sub Button_CreditSale_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_CreditSale.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.AmountTotal = TextBox_AmountTotal.Text
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        If easyIntegrator1.CreditSale() Then
            TextBox_UniqueTransRef.Text = easyIntegrator1.resultsFields.UniqueTransID 'used to id the transaction for Voiding
            TextBox_Token.Text = easyIntegrator1.resultsFields.UniqueTransID
            Approved()
            ConvertSignature()
        Else : Decline()

        End If
    End Sub

    Private Sub Button_CreditReturn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_CreditReturn.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.AmountTotal = TextBox_AmountTotal.Text
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        If easyIntegrator1.CreditReturn() Then
            TextBox_UniqueTransRef.Text = easyIntegrator1.resultsFields.UniqueTransID 'used to id the transaction for Voiding
            TextBox_Token.Text = easyIntegrator1.resultsFields.UniqueTransID
            Approved()
            ConvertSignature()
        Else : Decline()

        End If
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DebitSale.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.AmountTotal = TextBox_AmountTotal.Text
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        If easyIntegrator1.DebitSale() Then
            TextBox_UniqueTransRef.Text = easyIntegrator1.resultsFields.UniqueTransID 'used to id the transaction for Voiding
            TextBox_Token.Text = easyIntegrator1.resultsFields.UniqueTransID
            Approved()
            ConvertSignature()
        Else : Decline()
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DebitReturn.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.AmountTotal = TextBox_AmountTotal.Text
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        If easyIntegrator1.DebitReturn() Then
            TextBox_UniqueTransRef.Text = easyIntegrator1.resultsFields.UniqueTransID 'used to id the transaction for Voiding
            TextBox_Token.Text = easyIntegrator1.resultsFields.UniqueTransID
            Approved()
            ConvertSignature()
        Else : Decline()
        End If
    End Sub

    Private Sub Button_CreditSaveCard_Click(sender As Object, e As EventArgs) Handles Button_CreditSaveCard.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        If easyIntegrator1.CreditSaveCard() Then
            TextBox_Token.Text = easyIntegrator1.resultsFields.UniqueTransID
            MessageBox.Show("Token generated. Save to use on future sales.")
        End If
    End Sub

    Private Sub Button_TokenSale_Click(sender As Object, e As EventArgs) Handles Button_TokenSale.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.AmountTotal = TextBox_AmountTotal.Text
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        easyIntegrator1.transFields.UniqueTransRef = TextBox_Token.Text
        If easyIntegrator1.CreditSale() Then
            TextBox_UniqueTransRef.Text = easyIntegrator1.resultsFields.UniqueTransID
            Approved()
        End If
    End Sub

    Private Sub Button_GenericVoid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_GenericVoid.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.Clear()
        easyIntegrator1.transFields.UniqueTransRef = TextBox_UniqueTransRef.Text
        If easyIntegrator1.GenericVoid() Then
            Approved()
            TextBox_ResultFields.AppendText("Mark your transaction as having been Voided" & vbCrLf)
        Else : TextBox_ResultFields.AppendText("Leave your transaction as is and warn user." & vbCrLf)
        End If

    End Sub

    Private Sub Button_RequestSignature_Click(sender As Object, e As EventArgs) Handles Button_RequestSignature.Click
        easyIntegrator1.LoadSetup(TextBox_Setup.Text)
        easyIntegrator1.transFields.Cashier = TextBox_Cashier.Text
        easyIntegrator1.transFields.TransactionReference = TextBox_TransactionReference.Text
        If easyIntegrator1.requestSignature() Then
            ConvertSignature()
        Else SignatureBox.Image = New Bitmap(2, 2)
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check for Setup1.txt if not, create file
        If System.IO.File.Exists("Setup1.txt") = True Then
            Dim objReader As New System.IO.StreamReader("Setup1.txt")
            TextBox_Setup.Text = objReader.ReadToEnd
            objReader.Close()
        Else  'create file
            Dim oWrite As New System.IO.StreamWriter("Setup1.txt")
            oWrite.Close()
        End If
    End Sub
End Class
